"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }






var _chunkTEVD66DOjs = require('./chunk-TEVD66DO.js');

// src/core/index.ts
var _unplugin = require('unplugin');
var _pluginutils = require('@rollup/pluginutils');

// src/core/parse_ID.ts
var _path = require('path');
function parse_ID(id, root = "") {
  const [file, rawQuery] = id.split("?", 2);
  const filename = file.startsWith(root) ? file.replace(root, "").replace(/^\//, "") : file;
  const ext = _path.extname.call(void 0, file).slice(1);
  const query = rawQuery ? Object.fromEntries(new URLSearchParams(rawQuery)) : {};
  return {
    file: filename,
    isSfc: ext === "vue",
    isTsx: ext.startsWith("ts"),
    isMdx: ext.startsWith("md"),
    query
  };
}

// src/core/transform.ts
var _magicstring = require('magic-string'); var _magicstring2 = _interopRequireDefault(_magicstring);

// src/core/transform_SFC.ts



var _compilerdom = require('@vue/compiler-dom');

// src/core/transform_JSX.ts
var _core = require('@babel/core');
var _parser = require('@babel/parser');
function transform_JSX(code, cb, options, opts) {
  const { isTsx, startIndex = 0, startLine = 1, startColumn = 1 } = options;
  const pluginSet = new Set(opts.babelParserPlugins);
  pluginSet.add("jsx");
  if (isTsx) {
    pluginSet.add("typescript");
  }
  const ast = _parser.parse.call(void 0, code, {
    sourceType: "unambiguous",
    plugins: Array.from(pluginSet),
    startLine,
    // babel start at 0
    startColumn: startColumn - 1
  });
  _core.traverse.call(void 0, ast, {
    JSXOpeningElement({ node }) {
      const nameNode = node.name;
      if (!nameNode)
        return;
      const { start } = node.loc;
      const name = getJSXElementName(nameNode);
      const offset = start.index + startIndex + name.length + 1;
      cb(_chunkTEVD66DOjs.__spreadProps.call(void 0, _chunkTEVD66DOjs.__spreadValues.call(void 0, {}, start), {
        // babel starts at 0, so we need to add 1
        column: start.column + 1,
        offset
      }));
    }
  });
}
function getJSXElementName(nameNode) {
  let nameValue;
  if (_core.types.isJSXIdentifier(nameNode)) {
    nameValue = nameNode.name;
  } else if (_core.types.isJSXNamespacedName(nameNode)) {
    const { namespace, name } = nameNode;
    nameValue = `${namespace.name}:${name.name}`;
  } else {
    const nameValues = [];
    while (_core.types.isJSXMemberExpression(nameNode)) {
      nameValues.unshift(nameNode.property.name);
      nameNode = nameNode.object;
    }
    nameValues.unshift(nameNode.name);
    nameValue = nameValues.join(".");
  }
  return nameValue;
}

// src/core/transform_SFC.ts
function transform_SFC(code, cb, opts) {
  const ast = _compilerdom.parse.call(void 0, code);
  _compilerdom.transform.call(void 0, ast, {
    nodeTransforms: [
      (node) => {
        if (node.type === _chunkTEVD66DOjs.NodeTypes.ELEMENT && _chunkTEVD66DOjs.TagTypes.includes(node.tagType)) {
          const { start } = node.loc;
          const offset = start.offset + node.tag.length + 1;
          cb(_chunkTEVD66DOjs.__spreadProps.call(void 0, _chunkTEVD66DOjs.__spreadValues.call(void 0, {}, start), { offset }));
        }
      }
    ]
  });
  const jsxOpts = resolveJsxOptsForScript(ast);
  if (jsxOpts) {
    transform_JSX(jsxOpts.code, cb, jsxOpts, opts);
  }
}
function resolveJsxOptsForScript(ast) {
  var _a;
  const scriptNode = ast.children.find(
    (node) => node.tag === "script"
  );
  if (!scriptNode)
    return;
  const codeNode = scriptNode.children[0];
  if (!codeNode)
    return;
  const langProp = scriptNode.props.find(
    (prop) => prop.name === "lang"
  );
  if (!langProp)
    return;
  const lang = (_a = langProp.value) == null ? void 0 : _a.content;
  const isTsx = lang === "tsx";
  const isJsx = isTsx || lang === "jsx";
  if (isJsx) {
    const { offset, line, column } = codeNode.loc.start;
    return {
      isTsx,
      startIndex: offset,
      startLine: line,
      startColumn: column,
      code: codeNode.content
    };
  }
}

// src/core/transform_MDX.ts
var _mdastutilfrommarkdown = require('mdast-util-from-markdown'); var _mdastutilfrommarkdown2 = _interopRequireDefault(_mdastutilfrommarkdown);
var _mdastutilmdxjsx = require('mdast-util-mdx-jsx');
var _micromarkextensionmdxjs = require('micromark-extension-mdxjs'); var _micromarkextensionmdxjs2 = _interopRequireDefault(_micromarkextensionmdxjs);
var _unistutilvisit = require('unist-util-visit'); var _unistutilvisit2 = _interopRequireDefault(_unistutilvisit);
var mdxJsxRE = /^mdxJsx/;
function transform_MDX(code, cb) {
  const ast = _mdastutilfrommarkdown2.default.call(void 0, code, "utf-8", {
    extensions: [_micromarkextensionmdxjs2.default.call(void 0, )],
    mdastExtensions: [_mdastutilmdxjsx.fromMarkdown]
  });
  _unistutilvisit2.default.call(void 0, ast, (node) => {
    if (mdxJsxRE.test(node.type) && "name" in node && node.name != null) {
      const { start } = node.position;
      const offset = start.offset + node.name.length + 1;
      cb(_chunkTEVD66DOjs.__spreadProps.call(void 0, _chunkTEVD66DOjs.__spreadValues.call(void 0, {}, start), { offset }));
    }
  });
}

// src/core/transform.ts
function transform2(code, id, opts, isWebpack = false) {
  const { root, sourceMap } = opts;
  let s;
  const parsed = parse_ID(id, root);
  if (!isWebpack && parsed.query[_chunkTEVD66DOjs.TRACE_ID]) {
    return;
  }
  if (parsed.isSfc) {
    transform_SFC(code, replace, opts);
  } else if (parsed.isMdx) {
    transform_MDX(code, replace);
  } else {
    transform_JSX(code, replace, parsed, opts);
  }
  function replace(pos) {
    s || (s = new (0, _magicstring2.default)(code));
    const { offset, line, column } = pos;
    s.prependLeft(offset, ` ${_chunkTEVD66DOjs.TRACE_ID}="${parsed.file}:${line}:${column}"`);
  }
  if (s) {
    return {
      code: s.toString(),
      map: sourceMap ? s.generateMap() : null
    };
  }
}

// src/core/index.ts
var unpluginFactory = (options = {}, meta) => {
  if (!_chunkTEVD66DOjs.isDev.call(void 0, )) {
    return {
      name: "unplugin-vue-source"
    };
  }
  const opts = resolveOptions(options);
  const filter = _pluginutils.createFilter.call(void 0, opts.include, opts.exclude);
  const isWebpack = meta.framework === "webpack";
  return {
    name: "unplugin-vue-source",
    enforce: "pre",
    transformInclude(id) {
      const { file, query } = parse_ID(id);
      return query.raw == null && filter(file);
    },
    transform(code, id) {
      return transform2(code, id, opts, isWebpack);
    }
  };
};
function resolveOptions(opts) {
  var _a, _b, _c, _d, _e;
  return {
    root: (_a = opts.root) != null ? _a : process.cwd(),
    sourceMap: (_b = opts.sourceMap) != null ? _b : false,
    babelParserPlugins: (_c = opts.babelParserPlugins) != null ? _c : [],
    include: (_d = opts.include) != null ? _d : /\.(vue|jsx|tsx|mdx)$/,
    exclude: (_e = opts.exclude) != null ? _e : /\/node_modules\//
  };
}
var core_default = /* @__PURE__ */ _unplugin.createUnplugin.call(void 0, unpluginFactory);



exports.core_default = core_default;
